% Sample code from the book: "Colored Petri Nets for 
% Modeling of Discrete Systems: A practical approach with GPenSIM"
% 
% Example-26: MSF (Producers-Consumers with AOPN)
% Reggie.Davidrajuh@uis.no (c) 12 April 2023  
% File: Main Simulation File:  pc.m

clear all; clc; 

global global_info; % user data 
%global_info.PRINT_LOOP_NUMBER = 1; 
global_info.STOP_AT = 90;

pns = pnstruct('pc_pdf');

dyn.m0 = {'pSource1',3, 'pSource2',3};
dyn.ft = {'tCh1',10, 'tCh2',10, 'allothers',1};
dyn.re = {'Channel',1,inf}; % channel as a resource 
dyn.ip = {'tCh1', 1};   % higher priority to tCh1
pni = initialdynamics(pns, dyn);

sim = gpensim(pni);
prnss(sim);
plotp(sim, {'pConsumer1','pConsumer2'});
prnschedule(sim);
